// Definicija klase geometrijskih figura (Figura).

#ifndef __figura__h__
#define __figura__h__

#include "tacka2.h"

class Figura {
protected:
  Tacka T;                                           // Teziste figure.
public:
  virtual void postavi (const Real xx, const Real yy)// Postavljanje fig.
    { T = Tacka (xx, yy); }
  virtual void pomeri (const Real dx, const Real dy) // Pomeranje figure.
    { T = Tacka ( T.aps() + dx, T.ord() + dy); }
  virtual Real O () const =0 ;             // Obim.
  virtual Real P () const =0 ;             // Povrsina.
  virtual Real d () const =0 ;             // Dijagonala.
  virtual Real r () const =0 ;             // Poluprecnik upisanog kruga.
  virtual Real R () const =0 ;             // Poluprecnik opisanog kruga.
private:
  virtual istream &citaj (istream &dd) =0 ;       // Citanje.
  virtual ostream &pisi  (ostream &dd) const =0 ; // Pisanje.
  friend istream & operator>>(istream &dd, Figura &ff);//Uopsteno citanje
  friend ostream & operator<<(ostream &dd, const Figura &ff);//i pisanje.
} ;

// Definicije funkcija koje se ugradjuju neposredno u kod.

inline istream & operator>> (istream &dd, Figura &ff)       // Citanje.
  { return ff.citaj (dd); }

inline ostream & operator<< (ostream &dd, const Figura &ff) // Pisanje.
  { return ff.pisi  (dd); }

#endif
