// Definicije funkcija uz klasu Poli.

#include "poli.h"

Poli poli (const double *a, int n) {         // Formiranje polinoma.
  Poli q; q.n = -1; q.a = new double [n+1];
  if (q.a) { q.n = n ; for (int i=0; i<=n; i++) q.a[i] = a[i]; }
  return q;
}

void niz  (const Poli &p, double *a, int &n) // Smestanje polinoma u niz.
  { for (int i=0; i<=p.n; i++) a[i] = p.a[i]; n = p.n; }

Poli operator+ (const Poli &p1, const Poli &p2){ // Zbir dva polinoma.
  int m;
  if (p1.n == p2.n) for (m=p1.n; m>=0 && p1.a[m]+p2.a[m]==0; m--);
    else        m = (p1.n > p2.n) ? p1.n : p2.n;
  Poli q; q.a =  (m >= 0) ? new double [m+1] : 0;
  if (q.a) {
    q.n = m;
    for (int i=0; i<=m; i++)
      if      (i > p2.n)  q.a[i] = p1.a[i];
      else if (i > p1.n)  q.a[i] = p2.a[i];
      else                q.a[i] = p1.a[i] + p2.a[i];
  } else q.n = -1;
  return q;
}

Poli operator- (const Poli &p1, const Poli &p2){ // Razlika dva polinoma.
  int m;
  if (p1.n == p2.n) for (m=p1.n; m>=0 && p1.a[m]-p2.a[m]==0; m--);
    else        m = (p1.n > p2.n) ? p1.n : p2.n;
  Poli q; q.a = (m >= 0) ? new double [m+1] : 0;
  if (q.a) {
    q.n = m;
    for (int i=0; i<=m; i++)
      if      (i > p2.n)  q.a[i] = p1.a[i];
      else if (i > p1.n)  q.a[i] = p2.a[i];
      else                q.a[i] = p1.a[i] - p2.a[i];
  } else q.n = -1;
  return q;
}

Poli operator* (const Poli &p1, const Poli &p2){// Proizvod dva polinoma.
  int m = (p1.n>=0 && p2.n>=0) ? p1.n+p2.n : -1;
  Poli q; q.a = (m >= 0) ? new double [m+1] : 0;
  if (q.a) {
    q.n = m;
    for (int i=0; i<=m; q.a[i++]=0);
    for (i=0; i<=p1.n; i++)
      for (int j=0; j<=p2.n; j++)
        q.a[i+j] += p1.a[i] * p2.a[j];
  } else q.n = -1;
  return q;
}

double Poli::operator() (double x) const    // Vrednost polinoma.
  { double s = 0; for (int i=n; i>=0; (s*=x)+=a[i--]); return s; }

Poli & Poli::operator= (const Poli &p) {    // Dodela vrednosti polinomu.
  if (&p != this) {
    ~(*this); a = (p.n >= 0) ? new double [p.n+1] : 0;
    if (a) { n = p.n; for (int i=0; i<=n; i++) a[i] = p.a[i]; }
  }
  return *this;
}

istream & operator>> (istream &d, Poli &p) {       // Citanje polinoma.
  ~p; int n; d >> n; p.n = -1; p.a = new double [n+1];
  if (p.a) { p.n = n; for (int i=n; i>=0; d >> p.a[i--]); }
  return d;
}

ostream & operator<< (ostream &d, const Poli &p) { // Pisanje polinoma.
  d << "p[";
  for (int i=p.n; i>=0; i--) d << p.a[i] << (i ? "," : "");
  d << "]";
  return d;
}
