// Definicije funkcija uz klasu Red.

#include "red.h"

void Red::kopiraj (const Red &r) {   // Kopiranje reda.
  for (Elem *tek=r.prvi; tek; tek=tek->nar) {
    Elem *novi = new Elem; novi->pod = tek->pod; novi->nar = 0;
    if (posl) posl->nar = novi; else prvi = novi;
    posl = novi; duz++;
  }
}

void Red::brisi () {                 // Brisanje svih elemenata reda.
  while (prvi) { Elem *stari=prvi; prvi = prvi->nar; delete stari; }
  posl = 0; duz = 0;
}

Red::Red (int a) {                   // Konverzija int u Red.
  Elem *novi = new Elem; novi->pod = a; novi->nar = 0;
  prvi = posl = novi; duz = 1;
}

Red::Red (const Red &r)              // Kopirajuci konstruktor.
  { prvi = posl = 0; duz = 0; kopiraj (r); }

Red Red::operator= (const Red &r) {  // Dodela vrednosti.
  if (this != &r) { brisi (); kopiraj (r); }
  return *this;
}

Red Red::operator+= (const Red &r) { // Dodavanje reda.
  Red s = r;
  if (posl) posl->nar = s.prvi; else prvi = s.prvi;
  posl = s.posl; duz += s.duz;
  s.prvi = s.posl = 0; s.duz = 0;
  return *this;
}

Red Red::operator+ (const Red &r) const    // Spoj dva reda.
  { Red s = *this; s += r; return s; }

int Red::operator- () const        // Prvi element reda.
  { return duz ? prvi->pod : 0; }

int Red::operator-- () {           // Brisanje prvog elementa iz reda.
  if (duz) {
    int pod = prvi->pod;
    Elem *stari = prvi; prvi = prvi->nar; delete stari;
    if (! prvi) posl = 0;
    duz--;
    return pod;
  } else return 0;
}

Red Red::operator- (int k) const { // Red bez elemenata jednakih k.
  Red r;
  for (Elem *tek=prvi; tek; tek=tek->nar) if (tek->pod != k) r+=tek->pod;
  return r;
}

Red Red::operator-= (int k)        // Brisanje svih elemenata jednakih k.
  { return *this = *this - k; }

Red Red::operator~ ()              // Brisanje svih elemenata.
  { brisi (); return *this; }
