// Definicija klase za relativne datoteke (RFile).

#include <fstream.h>

class RFile : fstream {
  long duz_zap, bro_zap, tek_zap, tek_poz; //bro_zap==-1 - nije otvorena.
  int otvori (const char *ime, long duz=0);//Otvaranje datoteke (duz>0 
                                           //  formiranje nove datoteke).
public:
  enum { OK    = 0,      // SIFRE GRESAKA:
         G_DUZ = 1,      //   neispravna duzina zapisa,
         G_BRO = 2,      //   neispravan redni broj zapisa,
         G_VEL = 3,      //   datoteka nije ceo broj zapisa,
         G_ZAT = 4,      //   datoteka nije otvorena,
         G_OTV = 5,      //   nije uspelo otvaranje,
         G_POZ = 6,      //   nije uspelo pozicioniranje,
         G_PIS = 7,      //   nije uspelo upisivanje,
         G_CIT = 8,      //   nije uspelo citanje,
         G_ZAP = 9       //   zapis ne postoji.
       } ;
  RFile () : fstream () { bro_zap = -1; }//Inic. bez otvaranja datoteke.
  RFile (const char *ime, long duz=0)    //Inic. sa otvaranjem datoteke.
    : fstream () { otvori (ime, duz); }
  int open (const char *ime, long duz=0) //Otvaranje datoteke.
    { return otvori (ime, duz); }
  int open () { return bro_zap >= 0; }   //Da li je datoteka otvorena?
  int write(const void *niz, long zap=0);//Pisanje zapisa(zap==0 - sekv).
  int read (void *niz, long zap=0) ;     //Citanje zapisa(zap==0 - sekv).
  int close () ;                         //Zatvaranje datoteke.
  long recn (){return bro_zap<0 ? -1 : bro_zap;}//Broj zapisa u datoteci.
  long recl (){return bro_zap<0 ? -1 : duz_zap;}//Duzina zapisa.
} ;
