// Definicija genericke klase za obradu stekova (Stek<>).

template <class Pod, int kap>
class Stek {
  Pod  stek[kap];                            // Stek u obliku niza.
  int  vrh;                                  // Indeks vrha steka.
  int  gre;                                  // Indikator greske.
public:
  Stek () { vrh = gre = 0; }                 // Inicijalizacija.
  void stavi (const Pod &pod) ;              // Smestanje podatka.
  void uzmi (Pod &pod) ;                     // Uzimanje podatka.
  int  vel () const { return vrh; }          // Broj podataka na steku.
  void brisi () { vrh = gre = 0; }           // Praznjenje steka.
  int  prazan () const { return vrh == 0; }  // Indikator praznog steka.
  int  pun () const { return vrh == kap; }   // Indikator punog steka.
  int  greska () const { return gre; }       // Indikator greske.
} ;

// Definicije funkcija uz klase Stek<>.

template <class Pod, int kap>
void Stek<Pod,kap>::stavi (const Pod &pod)   // Smestanje podatka.
  { if (! (gre = vrh == kap)) stek[vrh++] = pod; }

template <class Pod, int kap>
void Stek<Pod,kap>::uzmi (Pod &pod)           // Uzimanje podatka.
  { if (! (gre = vrh == 0)) pod = stek[--vrh]; }
