// Definicije funkcija uz klasu Tekst.

#include "tekst1.h"
#include <string.h>
#include <iostream.h>

void Tekst::brisi ()                  // Unistavanje teksta.
  { if (txt && !--txt->kor) { delete [] txt->niz; delete txt; } }

Tekst::Tekst (const char *n) {        // Inicijalizacija znakovnim nizom.
  if (n && strlen (n)) {
    txt = new Txt; txt->kor = 1;
    txt->niz = new char [strlen(n)+1]; strcpy (txt->niz, n);
  } else txt = 0;
}

Tekst::Tekst (const Tekst &t)         // Inicijalizacija tekstom.
  { txt = t.txt; if (txt) txt->kor++; }

Tekst Tekst::operator= (const Tekst &t) {          // Dodela vrednosti.
  if (this != &t) { brisi (); txt = t.txt; if (txt) txt->kor++; }
  return *this;
}

Tekst operator+ (const Tekst &t1, const Tekst &t2){// Spajanje tekstova.
  if (! t1.txt) return t2;
  if (! t2.txt) return t1;
  char *n = new char [strlen(t1.txt->niz) + strlen(t2.txt->niz) + 1];
  strcpy (n, t1.txt->niz); strcat (n, t2.txt->niz);
  Tekst u = n; delete [] n; return u;
}

Tekst Tekst::operator+= (const Tekst &t)           // Dopisivanje teksta.
  { return *this = *this + t; }

inline int len (const Tekst &t)                    // Duzina teksta.
  { return t.txt ? strlen (t.txt->niz) : 0; }

istream & operator>> (istream &d, Tekst &t)        // Citanje teksta.
  { char *n = new char [81]; d >> n; t = n; delete [] n; return d; }

ostream & operator<< (ostream &d, const Tekst &t)  // Pisanje teksta.
  { return d << t.txt->niz; }
