// Definicije funkcija i zajednickih clanova uz poboljsanu klasu Tekst.

#include "tekst2.h"
#include <string.h>

void Tekst::brisi () {                // Unistavanje teksta.
  if (txt && !--txt->kor) {
    (txt->preth ? txt->preth->sled : prvi) = txt->sled;
    (txt->sled  ? txt->sled->preth : posl) = txt->preth;
    delete [] txt->niz;
    delete txt;
    broj--;
  }
}

Tekst::Tekst (const char *n) {        // Inicijalizacija znakovnim nizom.
  if (n && strlen (n)) {
    int f;
    for (Txt *tek=prvi;
         tek && ((f=strcmp(tek->niz,n))<0); tek=tek->sled);
    if (tek && f == 0)
      (txt = tek)->kor++;
    else {
      txt = new Txt; txt->kor = 1;
      txt->niz = new char [strlen(n)+1]; strcpy (txt->niz, n);
      if (! prvi) {                // Jedini u listi.
        prvi = posl = txt; txt->sled = txt->preth = 0;
      } else if (! tek) {          // Iza poslednjeg.
        txt->sled = 0;               txt->preth = posl;
        if (posl) posl->sled = txt;  posl = txt;
      } else if (! tek->preth) {   // Ispred prvog.
        txt->preth = 0;              txt->sled = prvi;
        if (prvi) prvi->preth = txt; prvi = txt;
      } else {                     // Usred liste.
        txt->sled  = tek->preth->sled; tek->preth->sled = txt;
        txt->preth = tek->preth;       tek->preth = txt;
      }
      broj++;
    }
  } else txt = 0;
}

Tekst::Tekst (const Tekst &t)         // Inicijalizacija tekstom.
  { txt = t.txt; if (txt) txt->kor++; }

Tekst Tekst::operator= (const Tekst &t) {          // Dodela vrednosti.
  if (this != &t) { brisi (); txt = t.txt; if (txt) txt->kor++; }
  return *this;
}

Tekst operator+ (const Tekst &t1, const Tekst &t2){// Spajanje tekstova.
  if (! t1.txt) return t2;
  if (! t2.txt) return t1;
  char *n = new char [strlen(t1.txt->niz) + strlen(t2.txt->niz) + 1];
  strcpy (n, t1.txt->niz); strcat (n, t2.txt->niz);
  Tekst u = n; delete [] n; return u;
}

Tekst Tekst::operator+= (const Tekst &t)           // Dopisivanje teksta.
  { return *this = *this + t; }

inline int len (const Tekst &t)                    // Duzina teksta.
  { return t.txt ? strlen (t.txt->niz) : 0; }

istream & operator>> (istream &d, Tekst &t)        // Citanje teksta.
  { char *n = new char [81]; d >> n; t = n; delete [] n; return d; }

ostream & operator<< (ostream &d, const Tekst &t)  // Pisanje teksta.
  { return d << t.txt->niz; }

void Tekst::spisak () {               // Spisak svih tekstova.
  int poz = 0, duz;
  for (Txt *tek=prvi; tek; tek=tek->sled) { 
    if (poz + (duz = strlen (tek->niz) + 2) < 72) poz += duz;
      else  { cout << endl; poz = duz; }
    cout << "  " << tek->niz;
  }
  cout << endl;
}

Tekst::Txt *Tekst::prvi=0, *Tekst::posl=0; // Inicijalizacija zajednickih
int Tekst::broj = 0;                       //   podataka clanova.
