// Definicija poboljane klase tekstova (Tekst).

#include <iostream.h>

class Tekst {
  struct Txt {              // Element liste tekstova:
    int   kor;              //   broj koriscenja teksta,
    Txt  *sled, *preth;     //   pokazivaci na sledeci i prethodni tekst,
    char *niz;              //   pokazivac na znakovni niz.
  };
  Txt *txt;                 // Pokazivac na tekst.
  static Txt *prvi, *posl;  // Pokazivaci na prvi i poslednji tekst.
  static int broj;          // Ukupan broj tekstova.
  void brisi () ;           // Brisanje strukture teksta.
public:
  Tekst (const char *n ="") ;         // Inicijalizacija znakovnim nizom.
  Tekst (const Tekst &t) ;            // Inicijalizacija tekstom.
  ~Tekst () { brisi (); }             // Unistavanje.
  Tekst operator= (const Tekst &t) ;          // Dodela vrednosti.
  friend Tekst operator+ (const Tekst &t1,
                          const Tekst &t2) ;  // Spajanje tekstova.
  Tekst operator+= (const Tekst &t) ;         // Dopisivanje teksta.
  int operator+ () const {return txt ? txt->kor : 0;} // Broj koriscenja.
  friend int len (const Tekst &t) ;                   // Duzina teksta.
  friend istream & operator>> (istream &d, Tekst &t) ;       // Citanje.
  friend ostream & operator<< (ostream &d, const Tekst &t) ; // Pisanje.
  static int ukupno () { return broj; }       // Ukupan broj tekstova.
  static void spisak () ;                     // Spisak svih tekstova.
} ;
