// Definicija klase vektora realnih brojeva (Vekt).

class Vekt {                            // Podaci clanovi:
  int min, max;                         //   granice indeksa,
  int duz;                              //   broj komponenata,
  double *niz;                          //   niz komponenata.
                                        // Pomocne funkcije:
  void pravi (int poc, int kra) ;       //   formiranje vektora,
  void kopiraj (const Vekt v) ;         //   kopiranje vektora,
  void brisi () ;                       //   unistavanje vektora.
  
public:
  enum Greska { OK,                     // Kodovi gresaka:
                OPSEG,                  //   neispravan opseg indeksa,
                MEMORIJA,               //   dodela memorije nije uspela,
                PRAZAN,                 //   vektor je prazan,
                INDEKS,                 //   indeks je izvan opsega,
                DUZINA } ;              //   neusaglasene duzine vektora.
                                        // Konstruktori:
  Vekt () { niz = 0; }                  //   prazan niz,
  Vekt (int kra) { pravi (1, kra); }    //   podrazumevani pocetni indeks
  Vekt (int poc, int kra) {pravi(poc,kra);}//sa zadatim indeksima,
  Vekt (const Vekt &v) { kopiraj (v); } //   kopirajuci.
  ~Vekt () { brisi (); }                // Destruktor.
  Vekt & operator= (const Vekt &v) ;    // Dodela vrednosti.
  double & operator[] (int i) const ;   // Pristup komponenti.
  friend double operator*(const Vekt &v,// Skalarni proizvod.
                          const Vekt &w) ;
} ;
