// Definicija klase vremenskih intervala (Vreme).

#include <iostream.h>

class Vreme {
  long t;                                        // Vreme u sekundama.
public:
  friend Vreme vreme (int h, int m, int s) ;     // Sastavljanje vremena.
  friend Vreme vreme (long  s) ;                 // Sekunde u vreme.
  friend int   sat   (Vreme v) ;                 // Sati u vremenu.
  friend int   min   (Vreme v) ;                 // Minute u vremenu.
  friend int   sek   (Vreme v) ;                 // Sekunde u vremenu.
  friend long  Sek   (Vreme v) ;                 // Vreme u sekunde.
  friend Vreme operator+ (const Vreme &v) ;                     // +v
  friend Vreme operator- (const Vreme &v) ;                     // -v
  friend Vreme operator+ (const Vreme &v, const Vreme &w) ;     // v +  w
  friend Vreme operator- (const Vreme &v, const Vreme &w) ;     // v -  w
  friend Vreme operator* (const Vreme &v, const int k) ;        // v *  k
  friend Vreme operator/ (const Vreme &v, const int k) ;        // v /  k
  Vreme operator++ ()        { ++t; return *this; }             // ++t
  Vreme operator++ (int)     { Vreme w = *this; t++; return w; }// t++
  Vreme operator-- ()        { --t; return *this; }             // --t
  Vreme operator-- (int)     { Vreme w = *this; t--; return w; }// t--
  Vreme operator+= (Vreme v) { t += v.t; return *this; }        // t += v
  Vreme operator-= (Vreme v) { t -= v.t; return *this; }        // t -= v
  Vreme operator*= (int   k) { t *= k; return *this; }          // t *= k
  Vreme operator/= (int   k) { t /= k; return *this; }          // t /= k
  friend int operator<  (const Vreme &v, const Vreme &w) ;      // v <  w
  friend int operator<= (const Vreme &v, const Vreme &w) ;      // v <= w
  friend int operator>  (const Vreme &v, const Vreme &w) ;      // v >  w
  friend int operator>= (const Vreme &v, const Vreme &w) ;      // v >= w
  friend int operator== (const Vreme &v, const Vreme &w) ;      // v == w
  friend int operator!= (const Vreme &v, const Vreme &w) ;      // v != w
  friend istream & operator>>(istream &d, Vreme &v) ;     // Citanje.
  friend ostream & operator<<(ostream &d, const Vreme &v);// Ispisivanje.
} ;

// Definicije funkcija koje se neposredno ugradjuju u kod.

inline Vreme vreme (int h, int m, int s)
  {Vreme v; v.t = ((h * 60L + m) * 60 + s); return v; }
inline Vreme vreme (long  s) { Vreme v; v.t = s; return v; }
inline int   sat   (Vreme v) { return v.t / 3600; }
inline int   min   (Vreme v) { return (v.t / 60) % 60; }
inline int   sek   (Vreme v) { return v.t % 60; }
inline long  Sek   (Vreme v) { return v.t; }
inline Vreme operator+ (const Vreme &v) { return  v; }
inline Vreme operator- (const Vreme &v) { Vreme w; w.t = -v.t; return w;}
inline Vreme operator+ (const Vreme &v, const Vreme &w)
  { Vreme vw; vw.t = v.t + w.t; return vw; }
inline Vreme operator- (const Vreme &v, const Vreme &w)
  { Vreme vw; vw.t = v.t - w.t; return vw; }
inline Vreme operator* (const Vreme &v, const int k)
  { Vreme vk; vk.t = v.t * k; return vk; }
inline Vreme operator/ (const Vreme &v, const int k)
  { Vreme vk; vk.t = v.t / k; return vk; }
inline int operator< (const Vreme &v, const Vreme &w) {return v.t< w.t;}
inline int operator<=(const Vreme &v, const Vreme &w) {return v.t<=w.t;}
inline int operator> (const Vreme &v, const Vreme &w) {return v.t> w.t;}
inline int operator>=(const Vreme &v, const Vreme &w) {return v.t>=w.t;}
inline int operator==(const Vreme &v, const Vreme &w) {return v.t==w.t;}
inline int operator!=(const Vreme &v, const Vreme &w) {return v.t!=w.t;}
